<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BaseUpdatedOn StructType
 * @subpackage Structs
 */
abstract class BaseUpdatedOn extends AbstractStructBase
{
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Key;
    /**
     * The Informations
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Informations;
    /**
     * Constructor method for BaseUpdatedOn
     * @uses BaseUpdatedOn::setKey()
     * @uses BaseUpdatedOn::setInformations()
     * @param int $key
     * @param string $informations
     */
    public function __construct($key = null, $informations = null)
    {
        $this
            ->setKey($key)
            ->setInformations($informations);
    }
    /**
     * Get Key value
     * @return int
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param int $key
     * @return \StructType\BaseUpdatedOn
     */
    public function setKey($key = null)
    {
        // validation for constraint: int
        if (!is_null($key) && !(is_int($key) || ctype_digit($key))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($key, true), gettype($key)), __LINE__);
        }
        $this->Key = $key;
        return $this;
    }
    /**
     * Get Informations value
     * @return string
     */
    public function getInformations()
    {
        return $this->Informations;
    }
    /**
     * Set Informations value
     * @param string $informations
     * @return \StructType\BaseUpdatedOn
     */
    public function setInformations($informations = null)
    {
        // validation for constraint: string
        if (!is_null($informations) && !is_string($informations)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($informations, true), gettype($informations)), __LINE__);
        }
        $this->Informations = $informations;
        return $this;
    }
}
