<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InfoPicth StructType
 * @subpackage Structs
 */
class InfoPicth extends AbstractStructBase
{
    /**
     * The PitchId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PitchId;
    /**
     * The Width
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Width;
    /**
     * The Length
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Length;
    /**
     * Constructor method for InfoPicth
     * @uses InfoPicth::setPitchId()
     * @uses InfoPicth::setWidth()
     * @uses InfoPicth::setLength()
     * @param string $pitchId
     * @param string $width
     * @param string $length
     */
    public function __construct($pitchId = null, $width = null, $length = null)
    {
        $this
            ->setPitchId($pitchId)
            ->setWidth($width)
            ->setLength($length);
    }
    /**
     * Get PitchId value
     * @return string|null
     */
    public function getPitchId()
    {
        return $this->PitchId;
    }
    /**
     * Set PitchId value
     * @param string $pitchId
     * @return \StructType\InfoPicth
     */
    public function setPitchId($pitchId = null)
    {
        // validation for constraint: string
        if (!is_null($pitchId) && !is_string($pitchId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pitchId, true), gettype($pitchId)), __LINE__);
        }
        $this->PitchId = $pitchId;
        return $this;
    }
    /**
     * Get Width value
     * @return string|null
     */
    public function getWidth()
    {
        return $this->Width;
    }
    /**
     * Set Width value
     * @param string $width
     * @return \StructType\InfoPicth
     */
    public function setWidth($width = null)
    {
        // validation for constraint: string
        if (!is_null($width) && !is_string($width)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($width, true), gettype($width)), __LINE__);
        }
        $this->Width = $width;
        return $this;
    }
    /**
     * Get Length value
     * @return string|null
     */
    public function getLength()
    {
        return $this->Length;
    }
    /**
     * Set Length value
     * @param string $length
     * @return \StructType\InfoPicth
     */
    public function setLength($length = null)
    {
        // validation for constraint: string
        if (!is_null($length) && !is_string($length)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($length, true), gettype($length)), __LINE__);
        }
        $this->Length = $length;
        return $this;
    }
}
