<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanningResponse StructType
 * @subpackage Structs
 */
class PlanningResponse extends AbstractStructBase
{
    /**
     * The ProductsPlanning
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProductPlanning
     */
    public $ProductsPlanning;
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * Constructor method for PlanningResponse
     * @uses PlanningResponse::setProductsPlanning()
     * @uses PlanningResponse::setMessage()
     * @param \ArrayType\ArrayOfProductPlanning $productsPlanning
     * @param string $message
     */
    public function __construct(\ArrayType\ArrayOfProductPlanning $productsPlanning = null, $message = null)
    {
        $this
            ->setProductsPlanning($productsPlanning)
            ->setMessage($message);
    }
    /**
     * Get ProductsPlanning value
     * @return \ArrayType\ArrayOfProductPlanning|null
     */
    public function getProductsPlanning()
    {
        return $this->ProductsPlanning;
    }
    /**
     * Set ProductsPlanning value
     * @param \ArrayType\ArrayOfProductPlanning $productsPlanning
     * @return \StructType\PlanningResponse
     */
    public function setProductsPlanning(\ArrayType\ArrayOfProductPlanning $productsPlanning = null)
    {
        $this->ProductsPlanning = $productsPlanning;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \StructType\PlanningResponse
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
}
