<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for productInventoryFilter StructType
 * @subpackage Structs
 */
class ProductInventoryFilter extends AbstractStructBase
{
    /**
     * The attributeId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $attributeId;
    /**
     * The minValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $minValue;
    /**
     * The maxValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $maxValue;
    /**
     * Constructor method for productInventoryFilter
     * @uses ProductInventoryFilter::setAttributeId()
     * @uses ProductInventoryFilter::setMinValue()
     * @uses ProductInventoryFilter::setMaxValue()
     * @param int $attributeId
     * @param int $minValue
     * @param int $maxValue
     */
    public function __construct($attributeId = null, $minValue = null, $maxValue = null)
    {
        $this
            ->setAttributeId($attributeId)
            ->setMinValue($minValue)
            ->setMaxValue($maxValue);
    }
    /**
     * Get attributeId value
     * @return int
     */
    public function getAttributeId()
    {
        return $this->attributeId;
    }
    /**
     * Set attributeId value
     * @param int $attributeId
     * @return \StructType\ProductInventoryFilter
     */
    public function setAttributeId($attributeId = null)
    {
        // validation for constraint: int
        if (!is_null($attributeId) && !(is_int($attributeId) || ctype_digit($attributeId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($attributeId, true), gettype($attributeId)), __LINE__);
        }
        $this->attributeId = $attributeId;
        return $this;
    }
    /**
     * Get minValue value
     * @return int
     */
    public function getMinValue()
    {
        return $this->minValue;
    }
    /**
     * Set minValue value
     * @param int $minValue
     * @return \StructType\ProductInventoryFilter
     */
    public function setMinValue($minValue = null)
    {
        // validation for constraint: int
        if (!is_null($minValue) && !(is_int($minValue) || ctype_digit($minValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($minValue, true), gettype($minValue)), __LINE__);
        }
        $this->minValue = $minValue;
        return $this;
    }
    /**
     * Get maxValue value
     * @return int
     */
    public function getMaxValue()
    {
        return $this->maxValue;
    }
    /**
     * Set maxValue value
     * @param int $maxValue
     * @return \StructType\ProductInventoryFilter
     */
    public function setMaxValue($maxValue = null)
    {
        // validation for constraint: int
        if (!is_null($maxValue) && !(is_int($maxValue) || ctype_digit($maxValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxValue, true), gettype($maxValue)), __LINE__);
        }
        $this->maxValue = $maxValue;
        return $this;
    }
}
